module identity_mod

  implicit none

  contains

  integer function identity_op(adj, add, model, data)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    call identity_op2(adj, add, model, data)
    identity_op = 0
  end function

  subroutine identity_op2(adj, add, model, data)
    logical,intent(in)          :: adj, add 
    real, dimension(:)   :: model
    real, dimension(:)   :: data	
    if(adj) then
      if(.not. add) model = 0.
      model = model + data
    else
      if(.not. add) data = 0.
      data = data + model
    end if
  end subroutine

end module
